c
c-----------------------------------------------------------------------
c
      real*8 function gammp (a, x)
c
c.....gammp - incomplete gamma function:
c
c                    1        /x  a-1  -t
c        P(a,x) = --------   /   t    e   dt     (a>0)
c                 gamma(a)  /0
c
      include           'implicit.inc'
      include           'error.inc'
      real*8            a, x, gamser, gammcf, gln
c
      real*8            ERROR_VALUE
      parameter         (ERROR_VALUE = 9.999999d29)
c
      if (x.lt.0d0 .or. a.le.0d0) then
         gammp = ERROR_VALUE
         call error ('gammp', 'arguments <= 0', warning)
         return
      endif
      if (x.lt.a+1d0) then
        call gser (gamser, a, x, gln)
        gammp = gamser
      else
        call gcf (gammcf, a, x, gln)
        gammp = 1d0 - gammcf
      endif
      return
      end
