c
c-----------------------------------------------------------------------
c
      real*8 function gammq (a, x)
c
c.....gammq - complementary of the incomplete gamma function.
c
      include           'implicit.inc'
      include           'error.inc'
c
      real*8            a, x, gamser, gammcf, gln
      real*8            ERROR_VALUE
      parameter         (ERROR_VALUE = 9.999999d29)
c
      if (x.lt.0d0 .or. a.le.0d0) then
         gammq = ERROR_VALUE
         call error ('gammq', 'arguments <= 0', warning)
         return
      else if (x.lt.a+1d0) then
        call gser(gamser,a,x,gln)
        gammq = 1d0-gamser
      else
        call gcf(gammcf,a,x,gln)
        gammq = gammcf
      endif
      return
      end
