c
c-----------------------------------------------------------------------
c
      subroutine gser (gamser, a, x, gln)
c
c.....gser - serial expansion for the incomplete gamma function
c
      include           'implicit.inc'
      include           'error.inc'
c
      real*8            gamser, a, x, gln, gammln
c
      real*8            ERROR_VALUE, eps
      integer           itmax
      parameter         (ERROR_VALUE = 9.999999d29)
      parameter         (itmax = 100, eps = 3.d-7)
      real*8            ap, sum, del
      integer           n
c
      gln = gammln(a)
      if (x.le.0d0) then
        if (x.lt.0d0) call error ('gser', 'argument x < 0', warning)
        gamser = 0d0
        return
      endif
      ap = a
      sum = 1d0/a
      del = sum
      do 11 n = 1, itmax
        ap = ap+1d0
        del = del*x/ap
        sum = sum+del
        if (abs(del).lt.abs(sum)*eps) go to 1
11    continue
      gamser = ERROR_VALUE
      call error ('gser', 'a too large, itmax too small', warning)
      return
1     gamser = sum*exp(-x+a*log(x)-gln)
      return
      end
