c
c-----------------------------------------------------------------------
c
      subroutine hinstall (name, rvalue, ivalue, type)
c
c.....hinstall - install variable into hashed table.
c
      include           'strtools.inc'
      include           'error.inc'
      include           'hash.inc'
      include           'tokens.inc'
      character*(*)     name
      character*(sstr)  dumbchar
      real*8            rvalue
      integer           ivalue, type
c
      integer           hash, hlookup, h
      real*8            oldrvalue
      integer           oldivalue, oldtype
c
c.....It is name an old variable?
c
      h = hlookup (name, oldrvalue, oldivalue, oldtype)
      if (h .gt. 0) then
         if (oldtype .eq. htconst .or. oldtype .eq. htfunction) then
         dumbchar='You cannot assign a new value '//
     &           'to a reserved keyword. Offending name:'//
     &           name(1:leng(name))
            call error ('hinstall',dumbchar,warning) 
         else
c
c...........Give new value to old variable:
c
            varrvalue(h) = rvalue
            varivalue(h) = ivalue
         endif
c
      else
c
c........This is a new var. Store its name and value:
c
         nvars = nvars + 1
         if (nvars .gt. mvars) call error ('hinstall',
     &      'Stack of variables exceeded. Increase MVARS!', faterr)
         varrvalue(nvars) = rvalue
         varivalue(nvars) = ivalue
         vartype(nvars)   = type
         varpos(nvars)    = bpointer
         ln = leng (name)
         bpointer = bpointer + ln + 1
         if (bpointer .gt. mbuf) call error ('hinstall',
     &      'Buffer of var names surpassed. Increase MBUF!', faterr)
         bnames(varpos(nvars):bpointer-1) = name(1:ln)//null
c
c........Find a position for name in the hash table:
c
         h = hash (name, hsize)
c
c........Store actual value of htable(h) in nextvar(nvars) to avoid
c        collisions:
c
         nextvar(nvars) = htable(h)
         htable(h) = nvars
      endif
      end
