c
c-----------------------------------------------------------------------
c
      real*8 function power (x, y, ierrcode)
c
c.....power - calculates the power x^y considering that:
c
c     x^y : (if x>0) -->  x**y
c         : (if y=0) -->  1
c         : (if x<0)  :  (if y is integer) : (if y is even) --> (-x)**y
c         :    "      :         "          : (if y is odd) --> -(-x)**y
c         :    "      :  (if y is non-integer) --> x^y is not defined.
c         : (if x=0) -->  0
c
      real*8            x, y
      integer           ierrcode
c
      integer           iy
      real*8            EPS
      parameter         (EPS = 1d-30)
c
      ierrcode = 0
      if (x .gt. 0d0) then
         power = x**y
      else if (abs(y) .le. EPS) then
         power = 1d0
      else if (x .lt. 0d0) then
         iy = int(y + 0.5d0)
         if (abs(y-dble(iy)) .le. EPS) then
            if (mod(iy,2) .eq. 0) then
               power = (-x)**y
            else
               power = -(-x)**y
            endif
         else
*mdc*if power_print
*            write (0,100)
*mdc*endif
            power = 0d0
            ierrcode = 1
         endif
      else
         power = 0d0
      endif
      return
c
*mdc*if power_print
* 100  format (1x, '*** Error (power) *** ',
*     & 'real powers of negative values are not defined')
*mdc*endif
c
      end
