c
c-----------------------------------------------------------------------
c
      subroutine randomstart (npts, uout)
c
c.....randomstart - distribute NPTS points uniformly on the surface
c     of an sphere of radius 1. The method consists on: (1) distribute
c     uniformly points on a cube -1 <= x,y,z <=1; (2) reject those
c     points that lie outside the sphere; and (3) project out all
c     remaining points onto the surface.
c
      include           'implicit.inc'
      include           'polyhedron.inc'
c
      integer           npts, uout
c
      integer           i, idum
      real*8            x, y, z, r, t, p, st
      real*8            ran1
c
      idum = -1
      i = 0
      do while (i.lt.npts)
         x = 2d0 * ran1(idum) - 1d0
         y = 2d0 * ran1(idum) - 1d0
         z = 2d0 * ran1(idum) - 1d0
         r = sqrt(x*x + y*y + z*z)
         if (r.le.1d0) then
            i = i + 1
            t = acos(z/r)
            p = atan2(y,x)
            st = sin(t)
            cth(i) = cos(t)
            sthcph(i) = st * cos(p)
            sthsph(i) = st * sin(p)
            xvert(i) = sthcph(i)
            yvert(i) = sthsph(i)
            zvert(i) = cth(i)
         endif
      enddo
      nvert = npts
      nvf = 3
c
      write (uout,100) nvert
 100  format (/
     & 1x, 'RANDOMSTART: Uniform random distribution of points on the'/
     & 1x, '             surface of an unit sphere.'/
     & 1x, 'Number of points: ', i6)
c
      end
