c
c-----------------------------------------------------------------------
c
      subroutine readoff (offfile, title, uout)
c
c.....readoff - read the polyhedron description from an OFF file.
c
      include           'implicit.inc'
      include           'error.inc'
      include           'polyhedron.inc'
      include           'strtools.inc'
c
      character*(*)     offfile, title
      integer           uout
c
      integer           luo, i, j, nedge, nface0, nn
      integer           idum(100)
      character*(20)    dumi
      character*(80)    line
c
      integer           leng, fopen
      logical           commentline
c
c.....Open the output file:
c
      if (fopen (luo, offfile, iowrite) .eq. iowrite) then
         call error ('readoff', 'I/O error when opening off file',
     &               warning)
         return
      endif
c
      color_mode = color_none
c
c.....Skip initial comment lines:
c
      do while (commentline(luo,line))
         continue
      enddo
      read (luo,'(a)') dumi
c
c.....Read vertices first:
c
      isw1 = 0
      read (luo,*) nvert, nface(isw1), nedge
      do j = 1, nvert
         read (luo,*) xvert(j), yvert(j), zvert(j)
      enddo
c
c.....Read now the faces of the polyhedron:
c     Reduce all faces to triangles.
c
      nface0 = 0
      nvf = 3
      do j = 1, nface(isw1)
*         read (luo,*) nvf, (iface(i,j,isw1)-1, i = 1, nvf)
         read (luo,*) nn, (idum(i), i = 1, nn)
         do i = 2, nn-1
            nface0 = nface0 + 1
            iface(1,nface0,isw1) = idum(1)-1
            iface(2,nface0,isw1) = idum(i)-1
            iface(3,nface0,isw1) = idum(i+1)-1
         enddo
      enddo
      nface(isw1) = nface0
c
      call fclose (luo)
c
      write (uout,200) offfile(1:leng(offfile)), nvert, nvf, nface(isw1)
 200  format (/
     & 1x, 'READOFF: reading a description of the object in the OFF'/
     & 1x, ' format.'//
     & 1x, 'Name of the OFF file:        ', a/
     & 1x, 'Number of vertices created:  ', i6/
     & 1x, 'Number of vertices per face: ', i6/
     & 1x, 'Number of faces:             ', i6)
c
      end
