      program tessel
c
      include           'implicit.inc'
      include           'copyright.inc'
      include           'tessel.doc'
c
      include           'error.inc'
      include           'stdio.inc'
      include           'strtools.inc'
c
      integer           uin, uout, lp, nios, i
      character*(600)   line, word
      character*(600)   uppcase, getword
      integer           leng, falloc
      logical           doagain, finputline
c
c.....Data structure for the run time arguments routine:
c
      integer           marg, mflg, mopt
      parameter         (marg = 2, mflg = 1, mopt = 1)
      character*(80)    arg(marg), optarg(mopt)
      logical           getopt, larg(marg), lflg(mflg), lopt(mopt)
      data (larg(i),i=1,marg) /marg*.false./
      data (lflg(i),i=1,mflg) /mflg*.false./
      data (lopt(i),i=1,mopt) /mopt*.false./
c
      include           'strtools.ini'
c
      call ioinit ()
      call povinit ()
      call tessinit ()
      call zhashinit ()
      call molinit ()
c
c.....Get run time arguments:
c
      if (.not. getopt(arg, larg, marg,
     &                 'h', lflg, mflg,
     &                 '?', lopt, mopt, optarg))
     &   call error ('tessel',
     &   'run program as: tessel [input [output]] ',
     &   faterr)
c
      if (lflg(1)) then
         write (6,*) 'Run program as:'
         write (6,*) 'tessel [input [output]]'
         stop 0
      endif
c
c.....Determine input source:
c
      if (larg(1)) then
         uin = falloc (uin)
         open (uin, file = arg(1), status = 'old', iostat = nios)
         if (nios.ne.0) call error ('tessel', 'Input file open error',
     &                              faterr)
      else
         uin = stdin
      endif
c
c.....Determine output destination:
c
      if (larg(2)) then
         uout = falloc (uout)
         open (uout, file = arg(2), status = 'unknown', iostat = nios)
         if (nios.ne.0) call error ('tessel', 'Output file open error',
     &                              faterr)
      else
         uout = stdout
      endif
c
      write (uout,100)
 100  format (
     & 1x, 'TESSEL: Tesselation of the sphere and creation of ',
     &     'parametric surfaces.'/
     & 1x,  'Copyright (c) 1996 Victor Lua~na'/
     & 15x, 'Departamento de Quimica Fisica'/
     & 15x, 'Universidad de Oviedo, 33006-Oviedo, Spain'/
     & 15x, 'http://www.uniovi.es/~quimica.fisica/qcg/vlc/luana.html'/)
c
      doagain = finputline (uin, line)
      do while (doagain)
         lp = 1
         word = uppcase (getword (word, line, lp))
         if (word(1:1) .eq. '#') then
c
c...........Ignore remark line:
c
            continue
c
         else if (word(1:leng(word)) .eq. 'PARAMETRIC') then
            call parametric (uin, uout)
c
         else if (word(1:leng(word)) .eq. 'TESSELATION') then
            call dotessel (uin, uout)
c
         else if (word(1:leng(word)) .eq. 'MISC') then
            call domisc (uin, uout)
c
         else if (word(1:leng(word)) .eq. 'MOLECULE') then
            call molecule (uin, uout)
c
         else if (word(1:leng(word)) .eq. 'SET') then
            call setvariables (line, lp, uout)
c
         else if (word(1:leng(word)) .eq. 'TESSINIT') then
            call tessinit ()
c
         else if (word(1:leng(word)) .eq. 'RESET') then
            call povinit ()
            call tessinit ()
            call molinit ()
c
         else if (word(1:leng(word)) .eq. 'END') then
            doagain = .false.
*
*mdc*if UNSECURERUN
c
         else if (word(1:leng(word)) .eq. 'RUN') then
            call spawn (line(lp:leng(line)))
*mdc*endif
*
c
         else
            call error ('tessel', 'order not recognized', faterr)
c
         endif
         if (doagain) doagain = finputline (uin, line)
c
      enddo
c
      if (larg(2)) then
         close (uout)
         call fdealloc (uout)
      endif
      if (larg(1)) then
         close (uin)
         call fdealloc (uin)
      endif
c
      end
