c
c-----------------------------------------------------------------------
c
      subroutine writepoints (pointsfile, title, uout)
c
c.....writepoints - write the polyhedron description as an POINTS file.
c
      include           'implicit.inc'
      include           'error.inc'
      include           'polyhedron.inc'
      include           'strtools.inc'
c
      character*(*)     pointsfile, title
      integer           uout
c
      integer           luo, j
      integer           leng, fopen
c
c.....Open the output file:
c
      if (fopen (luo, pointsfile, iowrite) .eq. ioerror) then
        call error ('writepoints', 'I/O error when opening points file',
     &              warning)
        return
      endif
c
      write (luo,100) 3
      write (luo,105) nvert
      do j = 1, nvert
         write (luo,110) xvert(j), yvert(j), zvert(j)
      enddo
c
      call fclose (luo)
c
 100  format (i1)
 105  format (i7)
 110  format (3f15.9)
c
      write (uout,200) pointsfile(1:leng(pointsfile)), nvert
 200  format (/
     & 1x, 'WRITEPOINTS: writing the vertices of the object in the'/
     & 1x, ' POINTS format to be manipulated with QuickHull.'//
     & 1x, 'Name of the POINTS file:     ', a/
     & 1x, 'Number of vertices created:  ', i6)
c
      end
